
package de.ivu.elect.presentation.benutzerverwaltung;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.benutzerverwaltung.entity.*;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.benutzerverwaltung.form.BenutzerEinsatzortViewFormBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

/**
 *  on 08.02.2017.
 */
@OnlineHilfeId(value = "662", mehrfachVergebenOk = true)
@RequestScoped
@Named(AbstractBenutzerEinsatzortEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractBenutzerEinsatzortEditNoScopeView.VIEW_ID, useCase = UseCasePermission.BENUTZER_EINSATZORT_EDIT)
public class BenutzerEinsatzortEditView extends AbstractBenutzerEinsatzortEditView {

  private static final long serialVersionUID = 1L;

  @Inject
  private BenutzerEinsatzortViewFormBuilder benutzerEinsatzortViewFormBuilder;

  public BenutzerEinsatzortEditView() {
    super();
  }

  @Override
  protected void addProperties(FormBuilder formBuilder, BenutzerEinsatzort entity) {
    benutzerEinsatzortViewFormBuilder.addProperties(formBuilder, entity);
  }

  @Override
  protected boolean isGebietBearbeitenRechtPruefen() {
    return false;
  }

  @Override
  protected void callSave(BenutzerEinsatzort entity) {
    Map<RolleArt, RollePickListProperty> rollenPropertiesNachArt = benutzerEinsatzortViewFormBuilder.getRollenPropertiesNachArt();
    if (!rollenPropertiesNachArt.isEmpty()) {
      Set<Rolle> neueRollen = new HashSet<>();

      for (RollePickListProperty rollePickListProperty : rollenPropertiesNachArt.values()) {
        neueRollen.addAll(rollePickListProperty.getZurgeordneteRollen());
      }
      entity.setRollen(neueRollen);
    }

    super.callSave(entity);
  }
}
